javascript:(function(){
    try
    {
        var dom = window.markM.peek();
        if (dom)
        {
            dom.removeAttribute('m_id');
            if(dom.hasAttribute('id'))
            {
                return dom.tagName + '#' + dom.getAttribute('id');
            };
            if(dom.classList.length)
            {
                let rule = '';
                for (let i=0;i<dom.classList.length;i++) {
                    rule = rule + '.' + dom.classList.item(i);
                }
                return dom.tagName + rule
            };
            if(dom.hasAttribute('href'))
            {
                return dom.tagName + '[href="' + dom.getAttribute('href') + '"]';
            }
            /*if(dom.hasAttribute('src'))
            {
                return dom.tagName + '[src="' + dom.getAttribute('src') + '"]';
            }*/
            if(dom.hasAttribute('style'))
            {
                return dom.tagName + '[style="' + dom.getAttribute('style') + '"]';
            }
            if(dom.hasAttribute('onclick'))
            {
                return dom.tagName + '[onclick="' + dom.getAttribute('onclick') + '"]';
            }
            let parent = dom;
            let query = dom.tagName;
            do{
                parent = parent.parentNode;
                if (parent)
                {
                    query = parent.tagName + ' > ' + query;
                }
            }while(!(parent.tagName === 'BODY'));
            return query;
        }
    } catch(e){
        alert(e);
    }
})();
