(function(){
    if(window.mark)return;
function Mark(){
	this.list=new Array();
	this.mask=document.createElement("moe");
    document.documentElement.appendChild(this.mask);
    this.mask.style.cssText="position: absolute !important; pointer-events: none !important; z-index: 2147483647 !important; background: rgba(120, 170, 210, 0.6) !important; transition: all 0.15s ease-out 0s !important; box-shadow: rgb(0, 0, 0) 0px 0px 0px 0px !important;outline: 1px dashed #707d8b;outline-offset: -1px;";
            
}
Array.prototype.isEmpty=function()
	{
		return this.length==0;
	}
	Array.prototype.clear=function()
	{
		this.length=0;
	}
	Array.prototype.peek=function()
	{
		if(this.length>0)
			return this[this.length-1];
		return null;
	}
Mark.prototype.set=function(e){
	this.list.clear();
	if(e)
	this.list.push(e);
	this.mark();
}
Mark.prototype.mark=function(){
	let e=this.list.peek();
	if(e){
		let box = e.getBoundingClientRect();
        let w=box.right-box.left,h=box.bottom-box.top;
        
        if (this.mask.offsetWidth < e.offsetWidth)
        {
            this.mask.style.left = (window.scrollX + box.left) + "px";
            this.mask.style.top = (window.scrollY + box.top) + "px";
            //window.mark.style.width = (box.right - box.left) + "px";
            //window.mark.style.height = (box.bottom - box.top) + "px";
            this.mask.style.width=w+"px";
            this.mask.style.height=h+"px";
        }
        else
        {
            this.mask.style.width=w+"px";
            this.mask.style.height=h+"px";
            //window.mark.style.width = (box.right - box.left) + "px";
            //window.mark.style.height = (box.bottom - box.top) + "px";
            this.mask.style.left = (window.scrollX + box.left) + "px";
            this.mask.style.top = (window.scrollY + box.top) + "px";

        }
	}

}
Mark.prototype.full=function(){
	let e=this.list.peek();
	if(e&&e.tagName!='HTML'){
		let p=e.parentNode;
		if(p){
		this.list.push(p);
		this.mark();
		}
	}
}
Mark.prototype.exit=function(){
	if(this.list.length>1){
		this.list.pop();
		this.mark();
	}
}
Mark.prototype.edit=function(){
	var element=this.list.peek();
	if(element){
		moe.toString(element.outerHTML.toString());
	}else{
		moe.toString('未找到标记的元素');
	} 
}
Mark.prototype.reset=function(){
	this.mask.style.width='0px';
	this.mask.style.height='0px';
	this.list.clear();
}
Mark.prototype.setValue=function(text){
	let doc=this.list.peek();
	if(doc){
		doc.outerHTML=text;
		this.reset();
	}
}
Mark.prototype.preview=function(s){
    if(s){
        this.mask.style.width='0px';
	    this.mask.style.height='0px';
        let style=document.createElement("style");
        style.id="moe_preview";
        style.innerHTML=this.block()+"{display:none!important;z-index: -1000!important;visibility: hidden!important;transform: scale(0,0)!important;width: 0px!important;height: 0px!important;max-width: 0px!important;max-height: 0px!important;}";
        document.head.appendChild(style);
    }else{
        document.querySelectorAll("#moe_preview").forEach(item=>{
            item.remove();
        });
        this.mark();
    }
}
Mark.prototype.precise=function(){
	try{
		let dom = this.list.peek();
		let index=[].indexOf.call(dom.parentElement.children, dom)+1;
        let hasStyle=dom.hasAttribute("style");
		return this.block()+":nth-child("+index+")"+(hasStyle?"[style]":"");
	}catch(e){
		alert(e);
	}
};
Mark.prototype.block=function(){
 try
    {
        let dom = this.list.peek();
        if (dom)
        {
            
            if(dom.hasAttribute('id'))
            {
                return dom.tagName + '#' + dom.getAttribute('id');
            };
            if(dom.classList.length)
            {
                let rule = '';
                for (let i=0;i<dom.classList.length;i++) {
                    rule = rule + '.' + dom.classList.item(i);
                }
                return dom.tagName + rule
            };
            if(dom.hasAttribute('href'))
            {
                return dom.tagName + '[href="' + dom.getAttribute('href') + '"]';
            }
            /*if(dom.hasAttribute('src'))
            {
                return dom.tagName + '[src="' + dom.getAttribute('src') + '"]';
            }*/
            /*if(dom.hasAttribute('style'))
            {
                return dom.tagName + '[style="' + dom.getAttribute('style') + '"]';
            }*/
            if(dom.hasAttribute('onclick'))
            {
                return dom.tagName + '[onclick="' + dom.getAttribute('onclick') + '"]';
            }
            let parent = dom;
            let query = dom.tagName;
            while(!(parent.tagName === 'BODY')){
                parent = parent.parentNode;
                if (parent)
                {
                	if(parent.hasAttribute('id')){
                		return parent.tagName+"#"+parent.getAttribute('id')+">"+query;
                	}
                	if(parent.classList.length)
            		{
                		let rule = '';
                		for (let i=0;i<parent.classList.length;i++) {
                    		rule = rule + '.' + parent.classList.item(i);
                		}
                		return parent.tagName + rule+">"+query;
            		};
                    query = parent.tagName + ' > ' + query;
                }
            };
            return query;
        }
        return "";
    } catch(e){
        alert(e);
    }
    return "";
}
if(!window.mark)window.mark=new Mark();
})();
